# frozen_string_literal: true

require 'import'
require 'graphql'
require 'cht-lib-fabric/tasks/actionable'

module FeatureConfig
  module Actions

    class Service
      include ::Platform::Tasks::Actionable

      def call
        context.service = service
      end

      def service
        ::FeatureConfig::Models::Service.new(
          sdl: GraphQL::Schema::Printer.print_schema(::FeatureConfig::Schema)
        )
      end
    end
  end
end