# frozen_string_literal: true

require 'cht-lib-fabric/dry_types'
require 'dry/struct'
require 'cht-lib-fabric/crns/organization'

module FeatureConfig
  module Models
    class CustomerInfo < ::Dry::Struct
      attribute :hasAlertlogicAccount, Platform::DryTypes::Bool.optional.default(false)
      attribute :hasAnsibleAccount, Platform::DryTypes::Bool.optional.default(false)
      attribute :hasBenchmarkPricingEnabled, Platform::DryTypes::Bool.optional.default(false)
      attribute :hasChefAccount, Platform::DryTypes::Bool.optional.default(false)
      attribute :hasDatadogAccount, Platform::DryTypes::Bool.optional.default(false)
      attribute :hasNewrelicAccount, Platform::DryTypes::Bool.optional.default(false)
      attribute :hasPuppetAccount, Platform::DryTypes::Bool.optional.default(false)
      attribute :defaultOrgId, Platform::CRNs::Organization.optional.default(nil)
      attribute :defaultOrgIsFlexOrg, Platform::DryTypes::Bool.optional.default(false)
      attribute :productEntitlements, Platform::DryTypes::Array.of(::Platform::DryTypes::Strict::String).optional.default([])

      class << self
        def from_string_hash(hash)
          new(
            hash.keys.each_with_object({}) do |key, acc|
              acc[Application[:inflector].camelize(key).to_sym] = hash[key]
            end
          )
        end
      end
    end
  end
end
