# frozen_string_literal: true

require 'import'
require 'ostruct'

module FeatureConfig
  module Stores
    class CustomerExtendedSetting
      include Import[
        'cache.customer_extended_setting_redis',
        :logger
      ]

      def from_customer_id(id)
        inflate(customer_extended_setting_redis.deserialize(id))
      end

      def inflate(raw_hash)
        return nil unless raw_hash

        raw_struct = raw_hash.keys.each_with_object({}) do |key, acc|
          acc[key] = raw_hash[key]
        end

        OpenStruct.new(
          raw_struct
        )
      end
    end
  end
end
