# frozen_string_literal: true

require 'import'
require 'ostruct'

module FeatureConfig
  module Stores
    class CustomerSetting
      include Import[
        'cache.customer_setting_redis',
        :logger
      ]

      def from_customer_id(id)
        inflate(customer_setting_redis.deserialize(id))
      end

      def inflate(raw_hash)
        return nil unless raw_hash

        OpenStruct.new(
          raw_hash.keys.each_with_object({}) do |key, acc|
            acc[key] = raw_hash[key]
          end
        )
      end
    end
  end
end
